### !/bin/tclsh

# verwenden im tcl-script: "source [diesesFile]" oder ". [diesesFile]"
# source [file join [file dirname [info script]] proc_htmlEntitaeten.tcl]

# -------------------------------------------------------------------------

# s. https://wiki.selfhtml.org/wiki/Referenz:HTML/Zeichenreferenz
# Bsp: set data [regsub-htmlEntitaeten $data]


if {0} {
  set t "Test mit &- und 
  den <>-Zeichen, sowie den Anführungszeichen 1x ' und 2x \" ..."
} elseif {0} {      
  set fp [open "ls.txt" r]
    set t [read $fp]
  close $fp
}


proc regsub-htmlEntitaeten { filedata } {

  # remove carriage return - control M - character, in Tcl strings represented as \r
  # regsub -all {\r} $filedata "" filedata;

  # '&' zuerst, weil danach ja welche eingefuegt werden
  # regsub -all "[format %c 38]" $filedata {\&amp;} filedata; 

  set filedata [string map "
{\r}            ''
[format %c 38]  {\&amp;}

{\"}            {\&quot;}
[format %c 39]  {\&apos;}
[format %c 60]  {\&lt;}
[format %c 62]  {\&gt;}

[format %c 128] {\&euro;}
[format %c 131] {\&fnof;}
[format %c 133] {\&hellip;}
[format %c 134] {\&dagger;}
[format %c 135] {\&Dagger;}
[format %c 149] {\&bull;}

[format %c 160] {\&nbsp;}
[format %c 161] {\&iexcl;}
[format %c 162] {\&cent;}
[format %c 163] {\&pound;}
[format %c 164] {\&curren;}
[format %c 165] {\&yen;}
[format %c 166] {\&brvbar;}
[format %c 167] {\&sect;}
[format %c 168] {\&uml;}
[format %c 169] {\&copy;}
[format %c 170] {\&ordf;}
[format %c 171] {\&laquo;}
[format %c 172] {\&not;}
[format %c 173] {\&shy;}
[format %c 174] {\&reg;}
[format %c 175] {\&macr;}
[format %c 176] {\&deg;}
[format %c 177] {\&plusmn;}
[format %c 178] {\&sup2;}
[format %c 179] {\&sup3;}
[format %c 180] {\&acute;}
[format %c 181] {\&micro;}
[format %c 182] {\&para;}
[format %c 183] {\&middot;}
[format %c 184] {\&cedil;}
[format %c 185] {\&sup1;}
[format %c 186] {\&ordm;}
[format %c 187] {\&raquo;}
[format %c 188] {\&frac14;}
[format %c 189] {\&frac12;}
[format %c 190] {\&frac34;}
[format %c 191] {\&iquest;}
[format %c 192] {\&Agrave;}
[format %c 193] {\&Aacute;}
[format %c 194] {\&Acirc;}
[format %c 195] {\&Atilde;}
[format %c 196] {\&Auml;}
[format %c 197] {\&Aring;}
[format %c 198] {\&AElig;}
[format %c 199] {\&Ccedil;}
[format %c 200] {\&Egrave;}
[format %c 201] {\&Eacute;}
[format %c 202] {\&Ecirc;}
[format %c 203] {\&Euml;}
[format %c 204] {\&Igrave;}
[format %c 205] {\&Iacute;}
[format %c 206] {\&Icirc;}
[format %c 207] {\&Iuml;}
[format %c 208] {\&ETH;}
[format %c 209] {\&Ntilde;}
[format %c 210] {\&Ograve;}
[format %c 211] {\&Oacute;}
[format %c 212] {\&Ocirc;}
[format %c 213] {\&Otilde;}
[format %c 214] {\&Ouml;}
[format %c 215] {\&times;}
[format %c 216] {\&Oslash;}
[format %c 217] {\&Ugrave;}
[format %c 218] {\&Uacute;}
[format %c 219] {\&Ucirc;}
[format %c 220] {\&Uuml;}
[format %c 221] {\&Yacute;}
[format %c 222] {\&THORN;}
[format %c 223] {\&szlig;}
[format %c 224] {\&agrave;}
[format %c 225] {\&aacute;}
[format %c 226] {\&acirc;}
[format %c 227] {\&atilde;}
[format %c 228] {\&auml;}
[format %c 229] {\&aring;}
[format %c 230] {\&aelig;}
[format %c 231] {\&ccedil;}
[format %c 232] {\&egrave;}
[format %c 233] {\&eacute;}
[format %c 234] {\&ecirc;}
[format %c 235] {\&euml;}
[format %c 236] {\&igrave;}
[format %c 237] {\&iacute;}
[format %c 238] {\&icirc;}
[format %c 239] {\&iuml;}
[format %c 240] {\&eth;}
[format %c 241] {\&ntilde;}
[format %c 242] {\&ograve;}
[format %c 243] {\&oacute;}
[format %c 244] {\&ocirc;}
[format %c 245] {\&otilde;}
[format %c 246] {\&ouml;}
[format %c 247] {\&divide;}
[format %c 248] {\&oslash;}
[format %c 249] {\&ugrave;}
[format %c 250] {\&uacute;}
[format %c 251] {\&ucirc;}
[format %c 252] {\&uuml;}
[format %c 253] {\&yacute;}
[format %c 254] {\&thorn;}
[format %c 255] {\&yuml;}
" $filedata]

  return $filedata
}

### puts [regsub-htmlEntitaeten $t]
